#include "Game.hpp"

using std::vector;

Game::Game() :
    m_punter(0),
    m_numPunters(0)
{
}

Game::~Game()
{
}

void Game::serialize(vector<uint32_t>* pData) const
{
    auto& data = *pData;

    m_map.serialize(pData);

    data.push_back(m_punter);
    data.push_back(m_numPunters);

    for (uint32_t iRiver = 0; iRiver < m_map.m_numRivers; iRiver++)
    {
        data.push_back(m_claims[iRiver]);
    }
}

bool Game::deserialize(const vector<uint32_t>& data, size_t& pos)
{
    size_t size = data.size();

    if (!m_map.deserialize(data, pos))
    {
        return false;
    }

    if (pos + 2 + m_map.m_numRivers > size)
    {
        return false;
    }

    m_punter = data[pos++];
    m_numPunters = data[pos++];

    m_claims.resize(m_map.m_numRivers);
    for (uint32_t iRiver = 0; iRiver < m_map.m_numRivers; iRiver++)
    {
        m_claims[iRiver] = data[pos++];
    }

    return true;
}
