#ifndef GREEDYSOLVER_HPP
#define GREEDYSOLVER_HPP

#include "Common.hpp"
#include "Solver.hpp"

class GreedySolver : public Solver
{
public:
    GreedySolver();
    virtual ~GreedySolver() override;

    virtual uint32_t solve(const Game& game) override;
    virtual void getFutures(const Game& game,
                            std::vector<SolverFuture>* pFutures) override;
    virtual void serialize(std::vector<uint32_t>* pData) const override;
    virtual bool deserialize(const std::vector<uint32_t>& data,
                             size_t& pos) override;

private:
    uint32_t m_nextMove;
};

#endif
