#ifndef MAPGRAPHICS_HPP
#define MAPGRAPHICS_HPP

#include "Common.hpp"
#include "Map.hpp"
#include "Graphics.hpp"

class MapGraphics
{
public:
    MapGraphics(const std::string& title,
                const Map& map,
                const std::vector<uint32_t>* pClaims = nullptr,
                uint32_t punter = (uint32_t)-1);
    ~MapGraphics();

    // Modal
    void show();

    // Modeless
    bool create(std::string* pMsg = nullptr);
    void onClaims(const std::vector<uint32_t>* pClaims = nullptr,
                  uint32_t punter = (uint32_t)-1);
    bool getDestroyed() const { return m_destroyed; }
    void destroy();

private:
    void setClaims(const std::vector<uint32_t>* pClaims = nullptr,
                   uint32_t punter = (uint32_t)-1);

    std::string m_title;
    const Map& m_map;
    std::unique_ptr<std::vector<uint32_t>> m_pClaims;
    uint32_t m_punter;
    Graphics m_graphics;
    bool m_destroyRequested;
    bool m_destroyed;
};

#endif
