#include "RandomSolver.hpp"
#include "Game.hpp"
#include "Map.hpp"
#include <random>

RandomSolver::RandomSolver()
{
}

RandomSolver::~RandomSolver()
{
}

uint32_t RandomSolver::solve(const Game& game)
{
    auto& map = game.m_map;
    uint32_t numRivers = map.m_numRivers;
    uint32_t numUnclaimed = 0;
    for (uint32_t iRiver = 0; iRiver < numRivers; iRiver++)
    {
        if (game.m_claims[iRiver] == (uint32_t)-1)
        {
            numUnclaimed++;
        }
    }

    std::default_random_engine gen{std::random_device()()};
    std::uniform_int_distribution<uint32_t> dist(0, numUnclaimed - 1);
    uint32_t iUnclaimed = dist(gen);

    numUnclaimed = 0;
    for (uint32_t iRiver = 0; iRiver < numRivers; iRiver++)
    {
        if (game.m_claims[iRiver] == (uint32_t)-1)
        {
            if (numUnclaimed == iUnclaimed)
            {
                return iRiver;
            }
            numUnclaimed++;
        }
    }

    return (uint32_t)-1;
}
