#include "SequentialSolver.hpp"
#include "Game.hpp"
#include "Map.hpp"

using std::vector;

SequentialSolver::SequentialSolver() :
    m_nextClaim(0)
{
}

SequentialSolver::~SequentialSolver()
{
}

uint32_t SequentialSolver::solve(const Game& game)
{
    auto& map = game.m_map;
    uint32_t claim = (uint32_t)-1;
    if (m_nextClaim < map.m_numRivers &&
        game.m_claims[m_nextClaim] == (uint32_t)-1)
    {
        claim = m_nextClaim;
    }
    m_nextClaim++;
    return claim;
}

void SequentialSolver::serialize(vector<uint32_t>* pData) const
{
    pData->push_back(m_nextClaim);
}

bool SequentialSolver::deserialize(const vector<uint32_t>& data,
                                   size_t& pos)
{
    size_t size = data.size();
    if (pos + 1 > size)
    {
        return false;
    }

    m_nextClaim = data[pos++];
    return true;
}
